package com.zhongzheng.modules.course.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.course.bo.CourseEducationTierAddBo;
import com.zhongzheng.modules.course.bo.CourseEducationTierQueryBo;
import com.zhongzheng.modules.course.bo.CourseEducationTierEditBo;
import com.zhongzheng.modules.course.domain.CourseEducationTier;
import com.zhongzheng.modules.course.mapper.CourseEducationTierMapper;
import com.zhongzheng.modules.course.vo.CourseEducationTierVo;
import com.zhongzheng.modules.course.service.ICourseEducationTierService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 教育层次Service业务层处理
 *
 * @author ruoyi
 * @date 2021-11-01
 */
@Service
public class CourseEducationTierServiceImpl extends ServiceImpl<CourseEducationTierMapper, CourseEducationTier> implements ICourseEducationTierService {

    @Override
    public CourseEducationTierVo queryById(Long educatioId){
        CourseEducationTier db = this.baseMapper.selectById(educatioId);
        return BeanUtil.toBean(db, CourseEducationTierVo.class);
    }

    @Override
    public List<CourseEducationTierVo> queryList(CourseEducationTierQueryBo bo) {
        LambdaQueryWrapper<CourseEducationTier> lqw = Wrappers.lambdaQuery();
        lqw.eq(StrUtil.isNotBlank(bo.getTireStatus()), CourseEducationTier::getTireStatus, bo.getTireStatus());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<CourseEducationTierVo> entity2Vo(Collection<CourseEducationTier> collection) {
        List<CourseEducationTierVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, CourseEducationTierVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<CourseEducationTier> page = (Page<CourseEducationTier>)collection;
            Page<CourseEducationTierVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(CourseEducationTierAddBo bo) {
        CourseEducationTier add = BeanUtil.toBean(bo, CourseEducationTier.class);
        validEntityBeforeSave(add);
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(CourseEducationTierEditBo bo) {
        CourseEducationTier update = BeanUtil.toBean(bo, CourseEducationTier.class);
        validEntityBeforeSave(update);
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(CourseEducationTier entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
